package main

import (
	"sync"
	"testing"

	"github.com/bhcleek/play/foo/mock_foo"
	"github.com/golang/mock/gomock"
)

func TestHelloWorld(t *testing.T) {
	t.Run("dawg", func(t *testing.T) {
		t.Log("it's a log")
		t.Error("boo")
	})
	t.Error("dang")
	outer(t)
}

func TestMultiline(t *testing.T) {
	t.Error("this is an error\nand a second line, too")
}

func TestGoodbye(t *testing.T) {
	t.Run("indented", func(t *testing.T) {
		t.Error("do you like my hat\nI do like your hat")
	})
}

func TestOK(t *testing.T) {
	t.Run("indented", func(t *testing.T) {
	})
}
func TestPanic(t *testing.T) {
	t.Run("sub test", func(t *testing.T) {
		var wg sync.WaitGroup
		wg.Add(1)
		go func() {
			panic("poop")
			wg.Done()
		}()

		wg.Wait()
	})
}

func outer(t *testing.T) {
	//t.Helper()
	inner(t)
}

func inner(t *testing.T) {
	//t.Helper()
	//t.Fatal("teapot")
}

func TestMocked(t *testing.T) {
	ctrl := gomock.NewController(t)
	f := mock_foo.NewMockFooer(ctrl)
	f.EXPECT().Foo()
	//	f.Foo()
	ctrl.Finish()
}
